
#include <iostream>
#include <fstream>
#include <math.h>
#include <string.h>

using namespace std;

const double dx = 1.;
const double dt = .05;
const int length = 200;

const int nsteps = 200./dt;


const double a = 1;
const double b = -.5;
const double k = .3;


// orismoi synarthsewn non-advection (~) terms
// u(tilde)xxx
// par: poses paragwghseis ws pros x
// val: o pinakas me tis values
// der: o pinakas me tis derivatives
// ind: trexon index
double utp(int par, double val[], double der[], int ind);

// orismoi synarthsewn advection terms - paragwgoi 4hs ta3hs = 0
// uxxx
double up(int par, double val[], double der[], int ind);



int main () {
	

	double val[length], der[length];
	
	double valnew[length], dernew[length];
	
	double ut, utt, utx, uttx;
	double utxx, utxxx; //boh8htika
	int i;
	

	for (i=0; i<length; i++) {
		
		// plhrwsh tou pinaka val gia t=0
		if (i <  49) 
			val[i] = a ;
		else 
			val[i] = b;
	
		//plhrwsh tou pinaka der gia t=0
		der[i]=0;
		
	}
	
	//der[48] = -.5;
	//der[49] = -.5;
	
	
	
	ofstream output;
	
	output.open ("data.txt");
	
	for (i=1 ; i< length -1 ;i++) output << i << "\t" << val[i] << endl;
	output  << endl;


	
	
	for (int t=1; t<= nsteps ; t++) {
		
		
		for ( i=1; i< length -1 ;i ++) {
			
			ut = -val[i]*der[i] + k * utp(2,val,der,i);
			utx = - val[i] * up(2,val,der,i) - pow(der[i],2) + k*utp(3,val,der,i);
			
			utxx = -val[i] * up(3,val,der,i) - 3.* der[i]*up(2,val,der,i) + k* utp(4,val,der,i);
			utxxx = - 4.*der[i]*up(3,val,der,i) - 3.* pow(up(2,val,der,i),2) + k *utp(5,val,der,i);
			
			utt = - ut * der[i] - val[i] * utx + k* utxx;
			
			uttx = -2.*der[i]*utx - ut*up(2,val,der,i) - val[i]* utxx + k*utxxx;

			
			
			valnew[i] = val[i] + ut *dt + utt * pow(dt,2)/2.;
			dernew[i] = der[i] + utx * dt + uttx * pow(dt,2)/2.;
			
			// video output
			//if ((t%4) == 0) output << i << "\t" << valnew[i] << "\n" ;

			//normal output
			if (t == nsteps) output << i << "\t" << valnew[i] << "\n" ;
			
			
		} // end for prospelash mhkous stous pinakes
		
		
		//video output
		//if ((t%4) == 0) output << "\n";

		
		for (i=1 ; i< length -1 ; i++) {
			val[i] = valnew[i];
			der[i] = dernew[i];
		}
		
	} // end for e3eli3h xronou
	
	output.close();
	
	return 0;
	
} // end function main


double utp(int par, double val[], double der[], int ind) {

	double fi = val[ind];
	double fim1 = val[ind - 1];
	double fip1 = val[ind + 1];

	double fxi = der[ind];
	double fxim1 = der[ind - 1];
	double fxip1 = der[ind + 1];
	
	
	switch (par) {
	case 2:
		double dc;
			
		dc = 1./pow(dx,2) *(fip1 - 2.*fi + fim1) - 1./4./dx *(fxip1 - fxim1);
		return 2.*dc;	
		break;
	case 3:
		double cc;
			
		cc = 5./4./pow(dx,3) *(fip1 - fim1) - 1./4./pow(dx,2) *(fxip1 + 8.*fxi + fxim1);
		return 6.*cc;
		break;
	case 4:
		double bc;
		
		bc = -1./2./pow(dx,4) *(fip1 - 2.*fi + fim1) + 1./4./pow(dx,3)*(fxip1 - fxim1);
		return 24.*bc;
		break;
	case 5:
		double ac;
		
		ac = - 3./4./pow(dx,5) *(fip1 - fim1) + 1./4./pow(dx,4) *(fxip1 + 4.*fxi + fxim1);
		return 120.*ac;
		break;
	default:
		cout << "error " << par << ": invalid derivative no. at function utp \n";
	}
	
	return 0;
} //end function utp


double up (int par, double val[], double der[], int ind) {

//  oi sxoliasmenes synarthseis einai gia thn periptwsh pou u<0
	
	double fi = val[ind];
	double fim1 = val[ind - 1];
//	double fip1 = val[ind + 1];

	double fxi = der[ind];
	double fxim1 = der[ind - 1];
//	double fxip1 = der[ind + 1];
	
	switch (par) {
	case 2:
		double bu;
		
		bu = (2.*fxi + fxim1)/dx - 3./pow(dx,2)*(fi - fim1);
		return 2.*bu;
		break;
	case 3:
		double au;
		
		au = (fxi + fxim1)/pow(dx,2) - 2./pow(dx,3)*(fi - fim1);
		return 6.*au;
		break;
	default:
		cout << "error " << par << ": invalid derivative no. at function up \n";
	}

	return 0;
} // end function up





