// Panagiotis - Dimitrios Antoniades    AEM 4161
// pms Ypologistikhs Fysikhs  APTH	
// 04/2010
//
// kwdikas anaparagwghs twn 5 test-problems apo to biblio tou Torro
// me IDO pou sthn xronikh ths e3eli3h xrhsimopoiei Runge Kutta. H viscosity pou xrhsimopoieitai
// kathista thn methodo dynath na kanei capture ta strong shocks, alla dinei ligotero
// akribh apotelesmata sta mild tests
//
// XXX: h artificial viscosity pou xrhsimopoieitai,
//		prokeitai gia thn a.v. pou blepoume sthn ergasia twn
//		Nishiguchi, Yabe journal of computational physics 52, 390-413 (1983)

#include <iostream>
#include <fstream>
#include <math.h>
#include <string.h>


// manual .h
#include "./headers/global.h"
#include "./headers/hermite.h"
#include "./headers/funcs.h"




const double TOL = 10e-6;
const double dx = .01;
const double dt = .000001;
const int length = 200 + 2;

const int tfilter = 100;


const double a = .7;		//alpha sthn viscosity
const double b = 1.;
const double g = 1.4; 	// gamma





using namespace std;



double mabs(double num);



int main () {
	
	double ro[length], rod[length], yu[length], yud[length], en[length], end[length]; 
		
	
	double ronew[length], rodnew[length], yunew[length], yudnew[length], ennew[length], endnew[length];
	
	
	//boh8htika - emmesa
	double pe, qu, cs;	
	double pex, pexx ;
	double qux, quxx ;
	
	//runge kutta "k"
	double k1, kx1, l1, lx1, m1, mx1;
	double k2, kx2, l2, lx2, m2, mx2;
	
	int i;
	
	
	//ARXIKES SYN8HKES

	for (i=0; i<length; i++) {
		
		if (i <  100) {
			
			ro[i] = 1.;
			yu[i] = 0.;
			en[i] = 1000. / (g - 1.)/ro[i];	//idaniko aerio
						
		}
						
		else {
			ro[i] = 1.;
			yu[i] = 0.;
			en[i] = .01 / (g - 1.)/ro[i];
		}
		
		
		
		rod[i]=0.;
		yud[i]=0.;
		end[i]=0.;
	}
	
	//yud[99] = -13.;
	//yud[100] = -13.;
	//end[99] = (end[100]-end[98])/2./dx;
	//end[100] = (end[101]-end[99])/2./dx;
	
	
	ofstream outputr;
	ofstream outputu;
	ofstream outpute;
	ofstream outbug;
	
	outputr.open ("data_r.dat");
	outputu.open ("data_u.dat");
	outpute.open ("data_e.dat");
	outbug.open ("data_bug.dat");
	
			
	//for (int t=1; t<=50./dt ; t++) {
		
	for (int t=1; t<= 50000 ; t++) {
						
				
		for ( i=1; i< length -1 ;i ++) {
			
			k1 = dt *funcrot(rod[i],yu[i],yud[i],ro[i]);
			
			kx1 = dt * funcrotx(up(2,ro,rod,yu,i), yu[i], yud[i],rod[i], utp(2,yu,yud,i),ro[i]);
			
			
			pe = funcpe(ro[i],en[i]);		
			pex = funcpex(rod[i],en[i],ro[i],end[i]);
			pexx = funcpexx(utp(2,ro,rod,i),en[i], rod[i], end[i], ro[i], utp(2,en,end,i));
	

			
			//if (yud[i-1]<0 || yud[i]<0 || yud[i+1]<0)
			if ( yud[i]<0 )
			//if (1)
			{

			
				cs = funccs(en[i]);
				
				qu = funcqu(ro[i],cs,yud[i]);
				qux = funcqux(cs, rod[i], yud[i], ro[i], utp(2,yu,yud,i));
				quxx = funcquxx(cs, utp(2,ro,rod,i), yud[i], rod[i], utp(2,yu,yud,i),ro[i], utp(3,yu,yud,i));
				
						
				l1 = dt * funcyut (yu[i], yud[i], pex, qux, ro[i]);
				
				lx1 = dt * funcyutx(yud[i], yu[i], up(2,yu,yud,yu,i), pexx, quxx, ro[i], pex, qux, rod[i]);
								
				m1 = dt * funcent (yu[i], end[i], pe, qu, yud[i], ro[i]);
				
				mx1 = dt * funcentx (yud[i], end[i], yu[i], up(2,en,end,yu,i), pex, qux, ro[i], pe, qu, utp(2,yu,yud,i), rod[i]);

				pe =  funcpe(ro[i] + k1, en[i]+m1);		
				pex = funcpex(rod[i]+kx1, en[i]+m1, ro[i]+k1, end[i]+mx1);
				pexx = funcpexx(utp(2,ro,rod,i,k1,kx1),en[i]+m1, rod[i]+kx1, end[i]+mx1, ro[i]+k1, utp(2,en,end,i,m1,mx1));
				
				
				cs = funccs(en[i]+m1);
				qu = funcqu(ro[i]+k1,cs,yud[i]+lx1);
				qux = funcqux(cs, rod[i]+kx1, yud[i]+ lx1, ro[i] +k1, utp(2,yu,yud,i,l1,lx1));
				quxx = funcquxx(cs, utp(2,ro,rod,i,k1,kx1), yud[i]+lx1, rod[i]+kx1, utp(2,yu,yud,i,l1,lx1), ro[i]+k1, utp(3,yu,yud,i,l1,lx1));

				
				
				k2 = dt * funcrot( rod[i]+kx1 , yu[i]+l1 , yud[i]+lx1 , ro[i]+k1 );
				
				kx2 = dt* funcrotx( up(2,ro,rod,yu,i,k1,kx1,l1) , yu[i]+l1 , yud[i]+lx1 , rod[i]+kx1 , utp(2,yu,yud,i,l1,lx1) , ro[i]+k1);
				
				l2 = dt * funcyut ( yu[i]+l1 , yud[i]+lx1 , pex, qux, ro[i]);

				lx2 = dt * funcyutx(yud[i]+lx1, yu[i]+l1, up(2,yu,yud,yu,i,l1,lx1,l1),pexx,quxx,ro[i]+k1,pex,qux,rod[i]+kx1);
				
				m2 = dt *funcent(yu[i] +l1, end[i] + mx1, pe, qu, yud[i]+lx1, ro[i]+k1);

				mx2 = dt * funcentx(yud[i]+lx1, end[i]+mx1, yu[i]+l1, up(2,en,end,yu,i,m1,mx1,l1), pex, qux, ro[i]+k1, pe, qu,
					  utp(2,yu,yud,i,l1,lx1), rod[i]+kx1);

			} //end if "kapoia paragwgos taxythtas einai arnitikh (compression region)
			else {
				
				l1 = dt * funcyut (yu[i], yud[i], pex, 0., ro[i]);
				
				lx1 = dt * funcyutx(yud[i], yu[i], up(2,yu,yud,yu,i), pexx, 0., ro[i], pex, 0., rod[i]);
								
				m1 = dt * funcent (yu[i], end[i], pe, 0., yud[i], ro[i]);
				
				mx1 = dt * funcentx (yud[i], end[i], yu[i], up(2,en,end,yu,i), pex, 0., ro[i], pe, 0., utp(2,yu,yud,i), rod[i]);
				
				
				pe =  funcpe(ro[i] + k1, en[i]+m1);		
				pex = funcpex(rod[i]+kx1, en[i]+m1, ro[i]+k1, end[i]+mx1);
				pexx = funcpexx(utp(2,ro,rod,i,k1,kx1),en[i]+m1, rod[i]+kx1, end[i]+mx1, ro[i]+k1, utp(2,en,end,i,m1,mx1));
				
				
				
				k2 = dt * funcrot( rod[i]+kx1 , yu[i]+l1 , yud[i]+lx1 , ro[i]+k1 );
				
				kx2 = dt* funcrotx( up(2,ro,rod,yu,i,k1,kx1,l1) , yu[i]+l1 , yud[i]+lx1 , rod[i]+kx1 , utp(2,yu,yud,i,l1,lx1) , ro[i]+k1);
				
				l2 = dt * funcyut ( yu[i]+l1 , yud[i]+lx1 , pex, 0., ro[i]);
				
				lx2 = dt * funcyutx(yud[i]+lx1, yu[i]+l1, up(2,yu,yud,yu,i,l1,lx1,l1),pexx,0.,ro[i]+k1,pex,0.,rod[i]+kx1);
				
				m2 = dt *funcent(yu[i] +l1, end[i] + mx1, pe, 0., yud[i]+lx1, ro[i]+k1);
				
				mx2 = dt * funcentx(yud[i]+lx1, end[i]+mx1, yu[i]+l1, up(2,en,end,yu,i,m1,mx1,l1), pex, 0., ro[i]+k1, pe, 0.,
					  utp(2,yu,yud,i,l1,lx1), rod[i]+kx1);
				
							
			} //end else - mh compression region
						
		
						
			//e3eli3h ston xrono me taylor
			//valnew[i] = val[i] + ut *dt + utt * pow(dt,2)/2.;
			//dernew[i] = der[i] + utx * dt + uttx * pow(dt,2)/2.;
			
			ronew[i] = ro[i] + 1./2.*(k1 + k2);
			if(isnan(ronew[i])){
				cout << "abort : ronew[i] = NaN   x:" << i/100. << "\t t:" << t;
				return 0;
			}
			rodnew[i] = rod[i] + 1./2.*(kx1 + kx2);
			
			yunew[i] = yu[i] + 1./2.*(l1 + l2);
			yudnew[i] = yud[i] + 1./2.*(lx1 + lx2);
			
			ennew[i] = en[i] + 1./2.*(m1 + m2);				
			endnew[i] = end[i] + 1./2.*(mx1 + mx2);
			
		
			
			// APLO OUTPUT
			//if(t== int(.012/dt)) outputr << i/100. << "\t" << ronew[i] << "\n" ;
			
			
			// NORMAL OUTPUT

			if(t%tfilter==0){
				
				outputr << i << "\t" << ronew[i] << "\n" ;
				outputu << i << "\t" << yunew[i] << "\n" ;
				outpute << i << "\t" << ennew[i] << "\n" ;
		
			}

					
			
			
		
		} // end for prospelash mhkous stous pinakes
	
			
		// NORMAL OUTPUT

		if(t%tfilter==0){
			outputr << "\n";
			outputu << "\n";
			outpute << "\n";			
		}		
		


		for (i=1 ; i< length -1 ; i++) {
			ro[i] = ronew[i];
			rod[i] = rodnew[i];
			yu[i] = yunew[i];
			yud[i] = yudnew[i];
			en[i] = ennew[i];
			end[i] = endnew[i];
			
		}
		
		
				
	} // end for e3eli3h xronou
	
	outputr.close();
	outputu.close();
	outpute.close();
	outbug.close();
	
	
	
	return 0;
	
} // end function main






double mabs(double num) {
	if (num>=0) return num;
	else return -num;
	cout << "error in manual absolute function";
	return 0;
}





