# include <iostream>

using namespace std;

	
__global__ void initfunc(int *mat, int a , int length);
__global__ void mainfunc(int *mata, int *matb, int *matc, int length);




int main() {
	
	int length = 15;
	
	int output[length]; //host
	
	int * alpha, * betta, * gamma; //device
	
	int nbytes = length*sizeof(int);
	
	
	cudaMalloc((void **) &alpha, nbytes );
	cudaMalloc((void **) &betta, nbytes );
	cudaMalloc((void **) &gamma, nbytes );
	
	initfunc <<<3,5>>> (alpha, 0, length);
	initfunc <<<3,5>>> (betta, 1, length);
	
	dim3 threadsperblock, gridsize;
	threadsperblock.x = 6;
	gridsize.x = ceil(length / float(threadsperblock.x) );
	
	cout << "ektelesh me :" << endl << gridsize.x << "\t blocks" << endl <<
			threadsperblock.x << "\t threads per block" << endl << endl;
	
	mainfunc <<<gridsize, threadsperblock>>> (alpha, betta, gamma, length) ;
	
	
	cudaMemcpy(output, gamma, nbytes, cudaMemcpyDeviceToHost);
	
	for (int i=0; i<length ; i++ )  cout << output[i] << "\t" ;
	cout <<endl;
	
	
	return 0;
}


__global__ void initfunc(int *mat, int a , int length) {
	
	int i = blockIdx.x * blockDim.x + threadIdx.x;
	
	if (i < length) 
		mat[i] = i + a ;
			
}

__global__ void mainfunc(int *mata, int *matb, int *matc, int length) {
	
	int i = blockIdx.x * blockDim.x + threadIdx.x;
	
	if (i<length)
		matc[i] = mata[i] + matb[i] ;
	
}


