
#include <iostream>

using namespace std;


__global__ void function (int* a, int* b, int* c) {
	
	int idx = blockIdx.x *blockDim.x + threadIdx.x;
	
	a[idx] = blockIdx.x;
	b[idx] = threadIdx.x;
	c[idx] = blockIdx.x *blockDim.x + threadIdx.x;
	
}



int main () {
	
	int length = 15;
	
	int host_a[length], host_b[length], host_c[length];
	
	int *dev_a, *dev_b, *dev_c;
	
	cudaMalloc((void**) &dev_a, length*sizeof(int));
	cudaMalloc((void**) &dev_b, length*sizeof(int));
	cudaMalloc((void**) &dev_c, length*sizeof(int));
	
	
	function <<<3,5>>> (dev_a, dev_b, dev_c);
	
	
	cudaMemcpy(host_a, dev_a, length*sizeof(int), cudaMemcpyDeviceToHost);
	cudaMemcpy(host_b, dev_b, length*sizeof(int), cudaMemcpyDeviceToHost);
	cudaMemcpy(host_c, dev_c, length*sizeof(int), cudaMemcpyDeviceToHost);
	
	int i;
	
	for (i=0 ; i<length ; i++) cout << host_a[i] << "\t" ;
	cout << endl;
	for (i=0 ; i<length ; i++) cout << host_b[i] << "\t" ;
	cout << endl;
	for (i=0 ; i<length ; i++) cout << host_c[i] << "\t" ;
	cout << endl;
	
	
	return 0;
}