// Panagiotis - Dimitrios Antoniades    AEM 4161
// pms Ypologistikhs Fysikhs  APTH	
// 04/2010
//
// kwdikas anaparagwghs tou problhmatos twn Woodward - Collela
// "two interacting blast waves"
// me IDO pou sthn xronikh ths e3eli3h xrhsimopoiei Runge Kutta
// XXX: h artificial viscosity pou xrhsimopoieitai,
//		prokeitai gia thn a.v. pou blepoume sthn ergasia twn
//		Nishiguchi, Yabe journal of computational physics 52, 390-413 (1983)

#include <iostream>
#include <fstream>
#include <math.h>
#include <string.h>

#include <time.h>


// manual .h
#include "./headers/global.h"
#include "./headers/hermite.h"
#include "./headers/funcs.h"




const double dx = 1./800.;
const double dt = .0000001;


const int tfilter = 860;


const int mesh = 800; // actual cells
const int r = 5; // ta3h akribeias


const double a = 0.0;		//alpha sthn viscosity
const double b = 1.5;
const double g = 1.4; 	// gamma



using namespace std;



double mabs(double num);



int main () {
	
	int length = mesh + 2*r;
	
	
	double ro[length], rod[length], yu[length], yud[length], en[length], end[length]; 
		
	
	double ronew[length], rodnew[length], yunew[length], yudnew[length], ennew[length], endnew[length];
	
	
	
	//boh8htika - emmesa
	double pe, qu, cs;	
	double pex, pexx;
	double qux, quxx;


	//runge kutta "k"
	double k1, kx1, l1, lx1, m1, mx1;
	double k2, kx2, l2, lx2, m2, mx2;
	

	int i;
	
	
	//ARXIKES SYN8HKES

	for (i=0; i<length; i++) {
		
		ro[i] = 1.;
		
		if (i <  r + .1*mesh) {
											
			en[i] = 1000. / (g - 1.)/ro[i];	//idaniko aerio
						
		}
						
		else  if(( i >=  r + .1*mesh ) && ( i < r + mesh*.9 ) ){
									
			en[i] = .01 / (g - 1.)/ro[i];
		}
		else {
			
			en[i] = 100. / (g - 1.)/ro[i];
		}
		
		
		yu[i] = 0.;
		
		rod[i]=0.;
		yud[i]=0.;
		end[i]=0.;
		
	}
	
	
		
	//rod[97] = -.5;
	//rod[98] = -.5;
	//end[97] = -.5;
	//end[98] = -.5;
	
	
	ofstream output1v;
	ofstream output1r;
	ofstream output2v;
	ofstream output2r;
	
	output1v.open ("data_1v.dat");
	output1r.open ("data_1r.dat");
	output2v.open ("data_2v.dat");
	output2r.open ("data_2r.dat");
	
	
	
	
	int dummy; // deikths gia thn ylopoihsh tou de3iou toixous
	
	


	clock_t start = clock();



	//for (int t=1; t<=50./dt ; t++) {
		
	for (int t=1; t<=160000 ; t++) {

				
		for ( i=r ; i< r + mesh ;i ++) {
			
			k1 = dt *funcrot(rod[i],yu[i],yud[i],ro[i]);

			kx1 = dt * funcrotx(up(2,ro,rod,yu,i), yu[i], yud[i],rod[i], utp(2,yu,yud,i),ro[i]);
			
			
			pe = funcpe(ro[i],en[i]);
			pex = funcpex(rod[i],en[i],ro[i],end[i]);
			pexx = funcpexx(utp(2,ro,rod,i),en[i], rod[i], end[i], ro[i], utp(2,en,end,i));


			
			//if (yud[i-1]<0 || yud[i]<0 || yud[i+1]<0)
			if ( yud[i]<0 )
			//if (1)
			{


				cs = funccs(en[i]);
				
				qu = funcqu(ro[i],cs,yud[i]);
				qux = funcqux(cs, rod[i], yud[i], ro[i], utp(2,yu,yud,i));
				quxx = funcquxx(cs, utp(2,ro,rod,i), yud[i], rod[i], utp(2,yu,yud,i),ro[i], utp(3,yu,yud,i));
				

				l1 = dt * funcyut (yu[i], yud[i], pex, qux, ro[i]);
				
				lx1 = dt * funcyutx(yud[i], yu[i], up(2,yu,yud,yu,i), pexx, quxx, ro[i], pex, qux, rod[i]);
								
				m1 = dt * funcent (yu[i], end[i], pe, qu, yud[i], ro[i]);
				
				mx1 = dt * funcentx (yud[i], end[i], yu[i], up(2,en,end,yu,i), pex, qux, ro[i], pe, qu, utp(2,yu,yud,i), rod[i]);

				pe =  funcpe(ro[i] + k1, en[i]+m1);
				pex = funcpex(rod[i]+kx1, en[i]+m1, ro[i]+k1, end[i]+mx1);
				pexx = funcpexx(utp(2,ro,rod,i,k1,kx1),en[i]+m1, rod[i]+kx1, end[i]+mx1, ro[i]+k1, utp(2,en,end,i,m1,mx1));
				
				
				cs = funccs(en[i]+m1);
				qu = funcqu(ro[i]+k1,cs,yud[i]+lx1);
				qux = funcqux(cs, rod[i]+kx1, yud[i]+ lx1, ro[i] +k1, utp(2,yu,yud,i,l1,lx1));
				quxx = funcquxx(cs, utp(2,ro,rod,i,k1,kx1), yud[i]+lx1, rod[i]+kx1, utp(2,yu,yud,i,l1,lx1), ro[i]+k1, utp(3,yu,yud,i,l1,lx1));

				
				
				k2 = dt * funcrot( rod[i]+kx1 , yu[i]+l1 , yud[i]+lx1 , ro[i]+k1 );
				
				kx2 = dt* funcrotx( up(2,ro,rod,yu,i,k1,kx1,l1) , yu[i]+l1 , yud[i]+lx1 , rod[i]+kx1 , utp(2,yu,yud,i,l1,lx1) , ro[i]+k1);
				
				l2 = dt * funcyut ( yu[i]+l1 , yud[i]+lx1 , pex, qux, ro[i]);

				lx2 = dt * funcyutx(yud[i]+lx1, yu[i]+l1, up(2,yu,yud,yu,i,l1,lx1,l1),pexx,quxx,ro[i]+k1,pex,qux,rod[i]+kx1);
				
				m2 = dt *funcent(yu[i] +l1, end[i] + mx1, pe, qu, yud[i]+lx1, ro[i]+k1);

				mx2 = dt * funcentx(yud[i]+lx1, end[i]+mx1, yu[i]+l1, up(2,en,end,yu,i,m1,mx1,l1), pex, qux, ro[i]+k1, pe, qu,
					  utp(2,yu,yud,i,l1,lx1), rod[i]+kx1);

			} //end if "kapoia paragwgos taxythtas einai arnitikh (compression region)
			else {
				
				l1 = dt * funcyut (yu[i], yud[i], pex, 0., ro[i]);
				
				lx1 = dt * funcyutx(yud[i], yu[i], up(2,yu,yud,yu,i), pexx, 0., ro[i], pex, 0., rod[i]);

				m1 = dt * funcent (yu[i], end[i], pe, 0., yud[i], ro[i]);
				
				mx1 = dt * funcentx (yud[i], end[i], yu[i], up(2,en,end,yu,i), pex, 0., ro[i], pe, 0., utp(2,yu,yud,i), rod[i]);
				
				
				pe =  funcpe(ro[i] + k1, en[i]+m1);
				pex = funcpex(rod[i]+kx1, en[i]+m1, ro[i]+k1, end[i]+mx1);
				pexx = funcpexx(utp(2,ro,rod,i,k1,kx1),en[i]+m1, rod[i]+kx1, end[i]+mx1, ro[i]+k1, utp(2,en,end,i,m1,mx1));
				
				
				
				k2 = dt * funcrot( rod[i]+kx1 , yu[i]+l1 , yud[i]+lx1 , ro[i]+k1 );
				
				kx2 = dt* funcrotx( up(2,ro,rod,yu,i,k1,kx1,l1) , yu[i]+l1 , yud[i]+lx1 , rod[i]+kx1 , utp(2,yu,yud,i,l1,lx1) , ro[i]+k1);
				
				l2 = dt * funcyut ( yu[i]+l1 , yud[i]+lx1 , pex, 0., ro[i]);
				
				lx2 = dt * funcyutx(yud[i]+lx1, yu[i]+l1, up(2,yu,yud,yu,i,l1,lx1,l1),pexx,0.,ro[i]+k1,pex,0.,rod[i]+kx1);
				
				m2 = dt *funcent(yu[i] +l1, end[i] + mx1, pe, 0., yud[i]+lx1, ro[i]+k1);
				
				mx2 = dt * funcentx(yud[i]+lx1, end[i]+mx1, yu[i]+l1, up(2,en,end,yu,i,m1,mx1,l1), pex, 0., ro[i]+k1, pe, 0.,
					  utp(2,yu,yud,i,l1,lx1), rod[i]+kx1);
				

			} //end else - mh compression region
						

						
			//e3eli3h ston xrono me Runge Kutta
			
			ronew[i] = ro[i] + 1./2.*(k1 + k2);
			if(isnan(ronew[i])){
				cout << "abort : ronew[i] = NaN   x:" << i/100. << "\t t:" << t;
				return 0;
			}
			rodnew[i] = rod[i] + 1./2.*(kx1 + kx2);
			
			yunew[i] = yu[i] + 1./2.*(l1 + l2);
			yudnew[i] = yud[i] + 1./2.*(lx1 + lx2);
			
			ennew[i] = en[i] + 1./2.*(m1 + m2);
			endnew[i] = end[i] + 1./2.*(mx1 + mx2);
			

			
			// APLO OUTPUT
			//if(t== int(.012/dt)) outputr << i/100. << "\t" << ronew[i] << "\n" ;
			
			
			// NORMAL OUTPUT
			/*
			if(t%tfilter==0){
				
				output1r << i << "\t" << ronew[i] << "\n" ;
				output1v << i << "\t" << yunew[i] << "\n" ;

		
			}
			*/

		} // end for prospelash mhkous stous pinakes
	
		
		//NORMAL OUTPUT
		/*
		if(t%tfilter==0){
			output1r << "\n";
			output1v << "\n";
			//outputu << "\n";
			//outpute << "\n";			
		}		
		*/




		for ( i=r ; i< r + mesh ;i ++) {
		//for (i=1 ; i< length -1 ; i++) {
			ro[i] = ronew[i];
			rod[i] = rodnew[i];
			yu[i] = yunew[i];
			yud[i] = yudnew[i];
			en[i] = ennew[i];
			end[i] = endnew[i];
		}
		
		
		
		// synoriaka reflecting walls
		
		// aristero orio
		
		for (i=0 ; i < r ; i++) {
			
			ro[i]= ro[2*r-1-i];
			rod[i] = rod[2*r-1-i];
			yu[i] = -  yu[2*r-1-i];
			yud[i] = - yud[2*r-1-i];
			en[i] = en[2*r-1-i];
			end[i] = end[2*r-1-i];
		}
		
		// de3i orio
		
		dummy =1;
		
		for (i= r + mesh ; i < length ; i++) {
			
			ro[i]= ro[i - 2*dummy +1];
			rod[i] = rod[i - 2*dummy +1];
			yu[i] = -  yu[i - 2*dummy +1];
			yud[i] = - yud[i - 2*dummy +1];
			en[i] = en[i - 2*dummy +1];
			end[i] = end[i - 2*dummy +1];

			dummy++;
		} // telos de3is toixos
		
		
			
				
	} // end for e3eli3h xronou
	


	cout << "elapsed time : " << ( (double)clock() - start) / CLOCKS_PER_SEC << endl << endl;



		
	
	//OUTPUT SWSTA

	for (i=r ; i< r+ mesh ; i++) {

		output1r << i << "\t" << ro[i] << "\n" ;
		output1v << i << "\t" << yu[i] << "\n" ;

	}






	output1v.close();
	output1r.close();
	output2v.close();
	output2r.close();
	
	
	return 0;
	
} // end function main





double mabs(double num) {
	if (num>=0) return num;
	else return -num;
	cout << "error in manual absolute function";
	return 0;
}




