

#include "./headers/hermite.h"



double utp(int par, double val[], double der[], int ind, double k, double l) {

	double fi = val[ind] + k ;
	double fim1 = val[ind - 1] + k;
	double fip1 = val[ind + 1] + k;

	double fxi = der[ind] + l ;
	double fxim1 = der[ind - 1] + l;
	double fxip1 = der[ind + 1] + l ;
	
	
	switch (par) {
	case 2:
		double dc;
			
		dc = 1./pow(dx,2) *(fip1 - 2.*fi + fim1) - 1./4./dx *(fxip1 - fxim1);
		return 2.*dc;	
		break;
	case 3:
		double cc;
			
		cc = 5./4./pow(dx,3) *(fip1 - fim1) - 1./4./pow(dx,2) *(fxip1 + 8.*fxi + fxim1);
		return 6.*cc;
		break;
	case 4:
		double bc;
		
		bc = -1./2./pow(dx,4) *(fip1 - 2.*fi + fim1) + 1./4./pow(dx,3)*(fxip1 - fxim1);
		return 24.*bc;
		break;
	case 5:
		double ac;
		
		ac = - 3./4./pow(dx,5) *(fip1 - fim1) + 1./4./pow(dx,4) *(fxip1 + 4.*fxi + fxim1);
		return 120.*ac;
		break;
	default:
		cout << "error " << par << ": invalid derivative no. at function utp \n";
	}
	cout << "Den tha eprepe na eisai edw - utp func" ;
	return 0;
	
} //end function utp


double up (int par, double val[], double der[], double vel[], int ind, double k, double l, double m) {

//  oi sxoliasmenes synarthseis einai gia thn periptwsh pou u<0
	
	double fi = val[ind] + k;
	double fim1 = val[ind - 1] + k ;
	double fip1 = val[ind + 1] + k ;

	double fxi = der[ind] + l ;
	double fxim1 = der[ind - 1] + l ;
	double fxip1 = der[ind + 1] + l ;
	
		
	switch (par) {
	case 2:
		double bu;
		
		//if ( mabs(vel[ind]) < TOL ) return utp(par,val,der,ind);
		//else if (vel[ind] < 0)
		if (vel[ind] + m < 0)
			bu = - (2.*fxi + fxip1)/dx - 3./pow(dx,2)*(fi - fip1);
		else
			bu = (2.*fxi + fxim1)/dx - 3./pow(dx,2)*(fi - fim1);
				
		return 2.*bu;
		break;
	case 3:
		double au;
		
		//if ( mabs(vel[ind]) < TOL ) return utp(par,val,der,ind);
		//else if (vel[ind] < 0)
		if (vel[ind] + m < 0)
			au = (fxi + fxip1)/pow(dx,2) + 2./pow(dx,3)*(fi - fip1);
		else
			au = (fxi + fxim1)/pow(dx,2) - 2./pow(dx,3)*(fi - fim1);
		
		return 6.*au;
		break;
	default:
		cout << "error " << par << ": invalid derivative no. at function up \n";
	}
	
	cout << "Den tha eprepe na eisai edw - up func " ;
	
	return 0;
} // end function up

