// Panagiotis - Dimitrios Antoniades    AEM 4161
// pms Ypologistikhs Fysikhs  APTH	
// 04/2010
//
// kwdikas anaparagwghs tou problhmatos twn Woodward - Collela
// "two interacting blast waves"
// me IDO pou sthn xronikh ths e3eli3h xrhsimopoiei Taylor
// XXX: h artificial viscosity pou xrhsimopoieitai,
//		prokeitai gia thn a.v. pou blepoume sthn ergasia twn
//		Nishiguchi, Yabe journal of computational physics 52, 390-413 (1983)




#include <iostream>
#include <fstream>
#include <math.h>
#include <string.h>

#include <time.h>

using namespace std;

const double dx = 1./800.;
const double dt = .0000001;

const int mesh = 800; // actual cells
const int r = 5; // ta3h akribeias

const int tfilter = 100;



const double a = 0.;		//alpha sthn viscosity
const double b = 1.5;
const double g = 1.4; 	// gamma



// orismoi synarthsewn non-advection (~) terms
// u(tilde)xxx
// par: poses paragwghseis ws pros x
// val: o pinakas me tis values
// der: o pinakas me tis derivatives
// ind: trexon index
double utp(int par, double val[], double der[], int ind);

// orismoi synarthsewn advection terms - paragwgoi 4hs ta3hs = 0
// uxxx
double up(int par, double val[], double der[], double vel[], int ind);

double mabs(double num);



int main () {
	
	int length = mesh + 2*r ;
	
	
	double ro[length], rod[length], yu[length], yud[length], en[length], end[length]; 
		
	
	double ronew[length], rodnew[length], yunew[length], yudnew[length], ennew[length], endnew[length];
	
	
	// pros antikatastash stis taylor sxeseis
	double rot, rott, rotx, rottx;
	double yut, yutt, yutx, yuttx;
	double ent, entt, entx, enttx;
	
	
	//boh8htika - amesa
	double rotxx, yutxx, entxx,   yut3x;
	
	//boh8htika - emmesa
	double pe, qu, cs;	
	double pex, pexx, pe3x, pe4x, pet, petx, petxx;
	double qux, quxx, qu3x, qu4x, qut, qutx, qutxx;
	
	double qu1, qu2;
	double qux1, quxx1, qu3x1, qu4x1, qut1, qutx1, qutxx1;
	double qux2, quxx2, qu3x2, qu4x2, qut2, qutx2, qutxx2;
	
	int i;
	
	
	//ARXIKES SYN8HKES

	for (i=0; i<length; i++) {
		
		ro[i] = 1.;
		
		if (i <  r + .1*mesh) {
											
			en[i] = 1000. / (g - 1.)/ro[i];	//idaniko aerio
						
		}
						
		else  if(( i >=  r + .1*mesh ) && ( i < r + mesh*.9 ) ){
									
			en[i] = .01 / (g - 1.)/ro[i];
		}
		else {
			
			en[i] = 100. / (g - 1.)/ro[i];
		}
		
		
		yu[i] = 0.;
		
		rod[i]=0.;
		yud[i]=0.;
		end[i]=0.;
		
	}
	
	
		
	//rod[97] = -.5;
	//rod[98] = -.5;
	//end[97] = -.5;
	//end[98] = -.5;
	
	
	ofstream output1v;
	ofstream output1r;
	ofstream output2v;
	ofstream output2r;
	
	output1v.open ("data_1v.dat");
	output1r.open ("data_1r.dat");
	output2v.open ("data_2v.dat");
	output2r.open ("data_2r.dat");
	
	
	
	
	int dummy; // deikths gia thn ylopoihsh tou de3iou toixous

	
	clock_t start = clock();
	


	//for (int t=1; t<=50./dt ; t++) {
		
	for (int t=1; t<=160000 ; t++) {

				
		for ( i=r ; i< r + mesh ;i ++) {
			
			// sxeseis '1'
				
				rot = -rod[i]*yu[i] - ro[i]* yud[i];
				//rotx = - up(2,ro,rod,yu,i) * yu[i] - 2.*rod[i]*yud[i] - ro[i] * up(2,yu,yud,yu,i);
				//rotxx = - up(3,ro,rod,yu,i) * yu[i] - 3.*up(2,ro,rod,yu,i) * yud[i] - 3.* rod[i]*up(2,yu,yud,yu,i) - ro[i]*up(3,yu,yud,yu,i);
			
				//nea ro'
				rotx = - up(2,ro,rod,yu,i) * yu[i] - 2.*rod[i]*yud[i] - ro[i] * utp(2,yu,yud,i);
				rotxx = - up(2,yu,yud,yu,i) * rod[i] - 2.* yud[i] * up(2,ro,rod,yu,i) - yu[i] * up(3,ro,rod,yu,i) - utp(3,yu,yud,i) *ro[i]
				         -2.* utp(2,yu,yud,i)*rod[i] - yud[i] *utp(2,ro,rod,i);                                                                                                   
				
				
				pe = (g - 1.)*ro[i]*en[i];			
				pex = (g - 1.)*(rod[i]*en[i] + ro[i]*end[i]);
				pexx = (g - 1.)*(utp(2,ro,rod,i)*en[i] + 2.*rod[i]*end[i] + ro[i]*utp(2,en,end,i));
				pe3x = (g - 1.)*(utp(3,ro,rod,i)*en[i] + 3.*utp(2,ro,rod,i)*end[i] + 3.*rod[i]*utp(2,en,end,i) + ro[i]*utp(3,en,end,i));
				pe4x = (g - 1.)*(utp(4,ro,rod,i)*en[i] + 4.*utp(3,ro,rod,i)*end[i] + 6.*utp(2,ro,rod,i)*utp(2,en,end,i)
						+4.*rod[i]*utp(3,en,end,i) + ro[i]*utp(4,en,end,i));
			
			
		 // if (yud[i-1]<0 || yud[i]<0 || yud[i+1]<0)
			if (yud[i]<0)
			//if(0)
			{
								

				cs = sqrt(g*(g - 1.)*en[i]);
				
				qu1 = -a *dx* ro[i] * cs * yud[i]  ;
				qux1 = -a*dx*cs*(rod[i]*yud[i] + ro[i]*utp(2,yu,yud,i)) ;
				quxx1 = -a*dx*cs* (utp(2,ro,rod,i)*yud[i] + 2.*rod[i]*utp(2,yu,yud,i) + ro[i]*utp(3,yu,yud,i)) ;
				qu3x1 =  -a*dx*cs* (utp(3,ro,rod,i)*yud[i] + 3.*utp(2,ro,rod,i)*utp(2,yu,yud,i) + 3.*rod[i]*utp(3,yu,yud,i) 
						+ ro[i]*utp(4,yu,yud,i)) ;
				qu4x1 =  -a*dx*cs* (utp(4,ro,rod,i)*yud[i] + 4.*utp(3,ro,rod,i)*utp(2,yu,yud,i) + 6.*utp(2,ro,rod,i)*utp(3,yu,yud,i)
						+ 4.*rod[i]*utp(4,yu,yud,i)+ro[i]*utp(5,yu,yud,i)) ;
				
				
				qu2 = b * pow(dx,2) * ro[i]*pow(yud[i],2);
				
				qux2 = b * pow(dx,2)*( rod[i]*pow(yud[i],2) + 2.* ro[i]*yud[i]*utp(2,yu,yud,i) );
				
				quxx2 = b * pow(dx,2)*( utp(2,ro,rod,i)*pow(yud[i],2) + 4.* rod[i] * yud[i] *utp(2,yu,yud,i)
										+ 2.* ro[i] *pow(utp(2,yu,yud,i),2) + 2.*ro[i]*yud[i]*utp(3,yu,yud,i)  );
				
				qu3x2 = b * pow(dx,2)*( utp(3,ro,rod,i)*pow(yud[i],2) + 6.*utp(2,ro,rod,i)*yud[i]*utp(2,yu,yud,i)
										+ 6.*rod[i]*pow(utp(2,yu,yud,i),2) + 6.*rod[i]*yud[i]*utp(3,yu,yud,i)
										+ 6.*ro[i]*utp(2,yu,yud,i)*utp(3,yu,yud,i) + 2.*ro[i]*yud[i]*utp(4,yu,yud,i));
				
				qu4x2 = b * pow(dx,2)*( utp(4,ro,rod,i)*pow(yud[i],2) + 8.*utp(3,ro,rod,i)*yud[i]*utp(2,yu,yud,i)
										+ 12.*utp(2,ro,rod,i)*pow(utp(2,yu,yud,i),2) + 12.*utp(2,ro,rod,i)*yud[i]*utp(3,yu,yud,i)
										+ 24.*rod[i]*utp(2,yu,yud,i)*utp(3,yu,yud,i) + 8.*rod[i]*yud[i]*utp(4,yu,yud,i)
										+ 6.*ro[i]*pow(utp(3,yu,yud,i),2) + 8.*ro[i]*utp(2,yu,yud,i)*utp(4,yu,yud,i) 
										+ 2.*ro[i]*yud[i]*utp(5,yu,yud,i) );
				
								
				qu = qu1 + qu2;
				qux = qux1 + qux2;
				quxx = quxx1 + quxx2;
				qu3x = qu3x1 + qu3x2;
				qu4x = qu4x1 + qu4x2;
				
				
				// sxeseis '2'
				
				yut = - yu[i]*yud[i] - (pex + qux)/ro[i];
				yutx = -pow(yud[i],2) - yu[i] * up(2,yu,yud,yu,i) - (pexx + quxx)/ro[i] + (pex + qux)*rod[i]/pow(ro[i],2);
				ent = - yu[i]*end[i] - (pe + qu)*yud[i]/ro[i];
				entx = -yud[i]*end[i] - yu[i]*up(2,en,end,yu,i) - (pex + qux)*yud[i]/ro[i] - (pe + qu)*utp(2,yu,yud,i)/ro[i]
				         +(pe + qu)* yud[i]* rod[i]/pow(ro[i],2);
				
				yutxx = -3.*yud[i]*up(2,yu,yud,yu,i) - yu[i]*up(3,yu,yud,yu,i) - (pe3x + qu3x)/ro[i] + 2.*(pexx + quxx)*rod[i]/pow(ro[i],2)
						+(pex + qux)*utp(2,ro,rod,i)/pow(ro[i],2) - 2.*(pex + qux)*pow(rod[i],2)/pow(ro[i],3);
				entxx = -up(2,yu,yud,yu,i)*end[i] - 2.*yud[i]*up(2,en,end,yu,i) - yu[i]*up(3,en,end,yu,i) - (pexx + quxx)*yud[i]/ro[i] 
	 			        - 2.*(pex + qux)*utp(2,yu,yud,i)/ro[i] + 2.*(pex+qux)*yud[i]*rod[i]/pow(ro[i],2) - (pe+qu)*utp(3,yu,yud,i)/ro[i]
	 			        +2. *(pe + qu)*utp(2,yu,yud,i)*rod[i]/pow(ro[i],2) + (pe +qu)*yud[i]*utp(2,ro,rod,i)/pow(ro[i],2)
	 			        +(pe + qu)*yud[i] * pow(rod[i],2)/pow(ro[i],3)*(-2.);
				yut3x = -3.*pow(up(2,yu,yud,yu,i),2) - 4.*yud[i]*up(3,yu,yud,yu,i) - (pe4x + qu4x)/ro[i] + 3.*(pe3x+qu3x)*rod[i]/pow(ro[i],2)
						+3.*(pexx + quxx)*utp(2,ro,rod,i)/pow(ro[i],2) - 6.*(pexx+quxx)*pow(rod[i],2)/pow(ro[i],3)
						+ (pex + qux)*utp(3,ro,rod,i)/pow(ro[i],2) - 6.*(pex+qux)*rod[i]*utp(2,ro,rod,i)/pow(ro[i],3)
						+6.* (pex + qux)*pow(rod[i],3)/pow(ro[i],4);
				
				
				rott = - rotx * yu[i] - rod[i] * yut  - rot *yud[i] - ro[i]* yutx;
				//rottx = -rotxx * yu[i] - up(2,ro,rod,yu,i) *yut - 2.*rotx * yud[i] - 2.*rod[i]*yutx - rot * up(2,yu,yud,yu,i) - ro[i]*yutxx;
				
				//nea ro'
				rottx = -rotxx * yu[i] - up(2,ro,rod,yu,i) *yut - 2.*rotx * yud[i] - 2.*rod[i]*yutx - rot * utp(2,yu,yud,i) - ro[i]*yutxx;
				
				
				pet = (g - 1.)*(rot*en[i] + ent*ro[i]);
				petx =  (g - 1.)*(rotx *en[i] + rod[i]*ent + rot*end[i] + ro[i]*entx);
				petxx = (g - 1.)*(rotxx * en[i] + utp(2,ro,rod,i)*ent + 2.*rotx*end[i] + 2.*rod[i]*entx + rot *utp(2,en,end,i) + ro[i]*entxx);
				
		
				
				qut1 = 	-a*dx*cs* (rot *yud[i] + ro[i]*yutx) ;
				qutx1 = -a*dx*cs* (rotx *yud[i] +rod[i]*yutx + rot*utp(2,yu,yud,i) + ro[i]*yutxx);
				qutxx1 = -a*dx*cs* (rotxx* yud[i] + utp(2,ro,rod,i)*yutx + 2.*rotx*utp(2,yu,yud,i)
					+ 2.*rod[i]*yutxx + rot*utp(3,yu,yud,i) + ro[i]*yut3x );
			
				
				qut2 = b *pow(dx,2) *( rot *pow(yud[i],2) +2.*ro[i]*yud[i]*yutx);
				
				qutx2 =  b *pow(dx,2) *( rotx * pow(yud[i],2) + 2.* rot *yud[i]*utp(2,yu,yud,i) + 2.*rod[i]*yud[i]*yutx
										+2.*ro[i]*utp(2,yu,yud,i)*yutx + 2.*ro[i]*yud[i]*yutxx ); 
				
				qutxx2 =  b *pow(dx,2) *( rotxx * pow(yud[i],2) + 4.*rotx*yud[i]*utp(2,yu,yud,i) + 2.*rot*pow(utp(2,yu,yud,i),2)
										+ 2.*rot*yud[i]*utp(3,yu,yud,i) + 2.*utp(2,ro,rod,i)*yud[i]*yutx + 4.*rod[i]*utp(2,yu,yud,i)*yutx
										+4.*rod[i]*yud[i]*yutxx + 2.*ro[i]*utp(3,yu,yud,i)*yutx + 4.* ro[i]*utp(2,yu,yud,i)*yutxx
										+2.*ro[i]*yud[i] *yut3x);
							
				
				qut = qut1 + qut2;
				qutx = qutx1 + qutx2;
				qutxx = qutxx1 + qutxx2;
				
				// sxeseis '3'
				
				yutt = - yut*yud[i] - yu[i]*yutx - (petx + qutx)/ro[i] + (pex+ qux)*rot / pow(ro[i],2);
				yuttx =  - 2.*yutx*yud[i] - yut*up(2,yu,yud,yu,i) - yu[i]*yutxx - (petxx + qutxx)/ro[i] + (pexx + quxx)*rot/pow(ro[i],2)
						+(petx + qutx)*rod[i]/pow(ro[i],2) + (pex+qux)*rotx/pow(ro[i],2) + (pex+qux)*rod[i]*rot/pow(ro[i],3)*(-2.);
				entt = -yut*end[i] - yu[i]*entx - (pet+qut)*yud[i]/ro[i] - (pe+qu)*yutx/ro[i] + (pe+qu)* yud[i]*rot/pow(ro[i],2);
				enttx = - yutx*end[i] - yud[i]*entx - yut*up(2,en,end,yu,i) - yu[i]*entxx - (petx + qutx)*yud[i]/ro[i]
				        - (pex + qux)*yutx/ro[i] + (pex + qux)*yud[i]*rot/pow(ro[i],2) - (pet + qut)*utp(2,yu,yud,i)/ro[i]
	                    - (pe+qu)*yutxx/ro[i] + (pe+qu)*utp(2,yu,yud,i)*rot/pow(ro[i],2) + (pet+qut)*yud[i]*rod[i]/pow(ro[i],2)
	                    +(pe+qu)*yutx*rod[i]/pow(ro[i],2) +(pe+qu)*yud[i]*rotx/pow(ro[i],2) - 2.*(pe+qu)*yud[i]*rod[i]*rot/pow(ro[i],3);
				
								
				
			} //end if "kapoia paragwgos taxythtas einai arnitikh (compression region)
			else {
			
				// sxeseis '2'
				
				yut = - yu[i]*yud[i] - pex/ro[i];
				yutx = -pow(yud[i],2) - yu[i] * up(2,yu,yud,yu,i) - pexx/ro[i] + pex*rod[i]/pow(ro[i],2);
				ent = - yu[i]*end[i] - pe*yud[i]/ro[i];
				entx = -yud[i]*end[i] - yu[i]*up(2,en,end,yu,i) - pex*yud[i]/ro[i] - pe*utp(2,yu,yud,i)/ro[i]
				         +pe* yud[i]* rod[i]/pow(ro[i],2);
				
				yutxx = -3.*yud[i]*up(2,yu,yud,yu,i) - yu[i]*up(3,yu,yud,yu,i) - pe3x/ro[i] + 2.*pexx*rod[i]/pow(ro[i],2)
						+pex*utp(2,ro,rod,i)/pow(ro[i],2) - 2.*pex*pow(rod[i],2)/pow(ro[i],3);
				entxx = -up(2,yu,yud,yu,i)*end[i] - 2.*yud[i]*up(2,en,end,yu,i) - yu[i]*up(3,en,end,yu,i) - pexx*yud[i]/ro[i] 
	 			        - 2.*pex*utp(2,yu,yud,i)/ro[i] + 2.*pex*yud[i]*rod[i]/pow(ro[i],2) - pe*utp(3,yu,yud,i)/ro[i]
	 			        +2. *pe*utp(2,yu,yud,i)*rod[i]/pow(ro[i],2) + pe*yud[i]*utp(2,ro,rod,i)/pow(ro[i],2)
	 			        + pe*yud[i] * pow(rod[i],2)/pow(ro[i],3)*(-2.);
								
				rott = - rotx * yu[i] - rod[i] * yut  - rot *yud[i] - ro[i]* yutx;
				//rottx = -rotxx * yu[i] - up(2,ro,rod,yu,i) *yut - 2.*rotx * yud[i] - 2.*rod[i]*yutx - rot * up(2,yu,yud,yu,i) - ro[i]*yutxx;
				
				//nea ro'
				rottx = -rotxx * yu[i] - up(2,ro,rod,yu,i) *yut - 2.*rotx * yud[i] - 2.*rod[i]*yutx - rot * utp(2,yu,yud,i) - ro[i]*yutxx;
				
				
				pet = (g - 1.)*(rot*en[i] + ent*ro[i]);
				petx =  (g - 1.)*(rotx *en[i] + rod[i]*ent + rot*end[i] + ro[i]*entx);
				petxx = (g - 1.)*(rotxx * en[i] + utp(2,ro,rod,i)*ent + 2.*rotx*end[i] + 2.*rod[i]*entx + rot *utp(2,en,end,i) + ro[i]*entxx);
				
								
				// sxeseis '3'
				
				yutt = - yut*yud[i] - yu[i]*yutx - petx/ro[i] + pex*rot / pow(ro[i],2);
				yuttx =  - 2.*yutx*yud[i] - yut*up(2,yu,yud,yu,i) - yu[i]*yutxx - petxx/ro[i] + pexx*rot/pow(ro[i],2)
						+petx*rod[i]/pow(ro[i],2) + pex*rotx/pow(ro[i],2) + pex*rod[i]*rot/pow(ro[i],3)*(-2.);
				entt = -yut*end[i] - yu[i]*entx - pet*yud[i]/ro[i] - pe*yutx/ro[i] + pe* yud[i]*rot/pow(ro[i],2);
				enttx = - yutx*end[i] - yud[i]*entx - yut*up(2,en,end,yu,i) - yu[i]*entxx - petx*yud[i]/ro[i]
				        - pex*yutx/ro[i] + pex*yud[i]*rot/pow(ro[i],2) - pet*utp(2,yu,yud,i)/ro[i]
	                    - pe*yutxx/ro[i] + pe*utp(2,yu,yud,i)*rot/pow(ro[i],2) + pet*yud[i]*rod[i]/pow(ro[i],2)
	                    +pe*yutx*rod[i]/pow(ro[i],2) +pe*yud[i]*rotx/pow(ro[i],2) - 2.*pe*yud[i]*rod[i]*rot/pow(ro[i],3);
	
			} //end else - mh compression region
						
						
			
					
						
			//e3eli3h ston xrono me taylor
			//valnew[i] = val[i] + ut *dt + utt * pow(dt,2)/2.;
			//dernew[i] = der[i] + utx * dt + uttx * pow(dt,2)/2.;
			
			ronew[i] = ro[i] + rot *dt + rott *pow(dt,2)/2.;
			if(isnan(ronew[i])){
				cout << "abort : ronew[i] = NaN   t:" << t;
				return 0;
			}
			rodnew[i] = rod[i] + rotx *dt +rottx *pow(dt,2)/2.;
			
			yunew[i] = yu[i] + yut *dt + yutt *pow(dt,2)/2.;
			yudnew[i] = yud[i] + yutx *dt + yuttx *pow(dt,2)/2.;
			
			ennew[i] = en[i] + ent *dt + entt *pow(dt,2)/2.;
			endnew[i] = end[i] + entx *dt + enttx *pow(dt,2)/2.;
			
			
			// APLO OUTPUT
			
		//	if(t== int(.016/dt)) output1r << i/800. << "\t" << ronew[i] << "\n" ;
		//	if(t== int(.016/dt)) output1v << i/800. << "\t" << yunew[i] << "\n" ;
			
			
			// NORMAL OUTPUT
			/*
			if(t%tfilter==0){
				
				output1r << i/800. << "\t" << ronew[i] << "\n" ;
				output1v << i/800. << "\t" << yunew[i] << "\n" ;
				//outputu << i << "\t" << yunew[i] <<"\n" ;
				//outpute << i << "\t" << ennew[i] <<"\n" ;
		
			}
			*/
			
		} // end for prospelash mhkous stous pinakes
	
		
		// NORMAL OUTPUT
		/*
		if(t%tfilter==0){
			output1r << "\n";
			output1v << "\n";
			//outputu << "\n";
			//outpute << "\n";			
		}		
		*/
		
		for ( i=r ; i< r + mesh ;i ++) {
		//for (i=1 ; i< length -1 ; i++) {
			ro[i] = ronew[i];
			rod[i] = rodnew[i];
			yu[i] = yunew[i];
			yud[i] = yudnew[i];
			en[i] = ennew[i];
			end[i] = endnew[i];
		}
		
		
		// synoriaka reflecting walls
		
		// aristero orio
		
		for (i=0 ; i < r ; i++) {
			
			ro[i]= ro[2*r-1-i];
			rod[i] = rod[2*r-1-i];
			yu[i] = -  yu[2*r-1-i];
			yud[i] = - yud[2*r-1-i];
			en[i] = en[2*r-1-i];
			end[i] = end[2*r-1-i];
		}
		
		// de3i orio
		
		dummy =1;
		
		for (i= r + mesh ; i < length ; i++) {
			
			ro[i]= ro[i - 2*dummy +1];
			rod[i] = rod[i - 2*dummy +1];
			yu[i] = -  yu[i - 2*dummy +1];
			yud[i] = - yud[i - 2*dummy +1];
			en[i] = en[i - 2*dummy +1];
			end[i] = end[i - 2*dummy +1];

			dummy++;
		} // telos de3is toixos
		
		
			
				
	} // end for e3eli3h xronou
	
	


	cout << "elapsed time : " << ( (double)clock() - start) / CLOCKS_PER_SEC << endl << endl;




	//OUTPUT  SWSTA
	for (i=r ; i < r + mesh; i++) {

		output1r << i << "\t" << ro[i] << "\n" ;
		output1v << i << "\t" << yu[i] << "\n" ;

	}






	output1v.close();
	output1r.close();
	output2v.close();
	output2r.close();
	
	
	return 0;
	
} // end function main









double utp(int par, double val[], double der[], int ind) {

	double fi = val[ind];
	double fim1 = val[ind - 1];
	double fip1 = val[ind + 1];

	double fxi = der[ind];
	double fxim1 = der[ind - 1];
	double fxip1 = der[ind + 1];
	
	
	switch (par) {
	case 2:
		double dc;
			
		dc = 1./pow(dx,2) *(fip1 - 2.*fi + fim1) - 1./4./dx *(fxip1 - fxim1);
		return 2.*dc;	
		break;
	case 3:
		double cc;
			
		cc = 5./4./pow(dx,3) *(fip1 - fim1) - 1./4./pow(dx,2) *(fxip1 + 8.*fxi + fxim1);
		return 6.*cc;
		break;
	case 4:
		double bc;
		
		bc = -1./2./pow(dx,4) *(fip1 - 2.*fi + fim1) + 1./4./pow(dx,3)*(fxip1 - fxim1);
		return 24.*bc;
		break;
	case 5:
		double ac;
		
		ac = - 3./4./pow(dx,5) *(fip1 - fim1) + 1./4./pow(dx,4) *(fxip1 + 4.*fxi + fxim1);
		return 120.*ac;
		break;
	default:
		cout << "error " << par << ": invalid derivative no. at function utp \n";
	}
	cout << "Den tha eprepe na eisai edw - utp func" ;
	return 0;
	
} //end function utp


double up (int par, double val[], double der[], double vel[], int ind) {

//  oi sxoliasmenes synarthseis einai gia thn periptwsh pou u<0
	
	double fi = val[ind];
	double fim1 = val[ind - 1];
	double fip1 = val[ind + 1];

	double fxi = der[ind];
	double fxim1 = der[ind - 1];
	double fxip1 = der[ind + 1];
	
		
	switch (par) {
	case 2:
		double bu;
		
		if (vel[ind] < 0) 
			bu = - (2.*fxi + fxip1)/dx - 3./pow(dx,2)*(fi - fip1);
		else
			bu = (2.*fxi + fxim1)/dx - 3./pow(dx,2)*(fi - fim1);
				
		return 2.*bu;
		break;
	case 3:
		double au;
		
		if (vel[ind]<0)
			au = (fxi + fxip1)/pow(dx,2) + 2./pow(dx,3)*(fi - fip1);
		else
			au = (fxi + fxim1)/pow(dx,2) - 2./pow(dx,3)*(fi - fim1);
		
		return 6.*au;
		break;
	default:
		cout << "error " << par << ": invalid derivative no. at function up \n";
	}
	
	cout << "Den tha eprepe na eisai edw - up func " ;
	
	return 0;
} // end function up



double mabs(double num) {
	if (num>=0) return num;
	else return -num;
	cout << "error in manual absolute function";
	return 0;
}




