
#include "./headers/cu_funcs.h"


__global__ void init_cond(float* ro, float* rod, float* yu, float* yud, float* en, float* end, int length, int mesh, int r) {
	
	int idx = blockIdx.x*blockDim.x + threadIdx.x ;
	
	
	
	if (idx < r + 0.1f*mesh ){	
		

		ro[idx] = 1.0f;
		yu[idx] = 0.0f ;
		en[idx] = 1000.0f / (g - 1) / ro[idx] ;
		
		
		rod[idx] = 0.0f;
		yud[idx] = 0.0f;
		end[idx] = 0.0f;
		
		
	}	
	else if ( (idx >=  r + 0.1f*mesh)  && (idx < r + 0.9f*mesh )  ) {
		

		ro[idx] = 1.0f;
		yu[idx] = 0.0f ;
		en[idx] = 0.01f / (g - 1) / ro[idx] ;
		
		
		rod[idx] = 0.0f;
		yud[idx] = 0.0f;
		end[idx] = 0.0f;
		
	}
	else if ( (idx >= r + 0.9f*mesh) &&  (idx < length) ) {
	

		ro[idx] = 1.0f;
		yu[idx] = 0.0f ;
		en[idx] = 100.0f / (g - 1) / ro[idx] ;
		
		
		rod[idx] = 0.0f;
		yud[idx] = 0.0f;
		end[idx] = 0.0f;
		
		
		
	}
			


} 




__global__ void refresh(float* ro, float* rod, float* yu, float* yud, float* en, float* end,
		float* ronew, float* rodnew, float* yunew, float* yudnew, float* ennew, float* endnew,
		int length, int mesh, int r) {

	int i = blockIdx.x*blockDim.x + threadIdx.x ;
	
	int dummy = i - r - mesh + 1;
	
	if (i < r) { 	//aristero toixos
		
		ro[i]= ronew[2*r-1-i];
		rod[i] = rodnew[2*r-1-i];
		yu[i] = -  yunew[2*r-1-i];
		yud[i] = - yudnew[2*r-1-i];
		en[i] = ennew[2*r-1-i];
		end[i] = endnew[2*r-1-i];
		
	}
	
	else if( i >= r && i < r + mesh ){ // antikatastash
		
		ro[i] = ronew[i];
		rod[i] = rodnew[i];
		yu[i] = yunew[i];
		yud[i] = yudnew[i];
		en[i] = ennew[i];
		end[i] = endnew[i];
		
	}
	
	else if ( i >= r+ mesh && i < length) { //de3ios toixos
		
		ro[i]= ronew[i - 2*dummy +1];
		rod[i] = rodnew[i - 2*dummy +1];
		yu[i] = -  yunew[i - 2*dummy +1];
		yud[i] = - yudnew[i - 2*dummy +1];
		en[i] = ennew[i - 2*dummy +1];
		end[i] = endnew[i - 2*dummy +1];

		dummy++;
		
	}
	
}



