
#include "./headers/adv.h"




__global__ void advance(float* ro, float* rod, float* yu, float* yud, float* en, float* end,
						float* ronew, float* rodnew, float* yunew, float* yudnew, float* ennew, float* endnew,
						int mesh, int r){
	
	
	int i = blockIdx.x*blockDim.x + threadIdx.x ;
	
	
		
	
	if ( i >=r && i < r + mesh ) {
	
		
	
			//boh8htika - emmesa
			float pe, qu, cs;	
			float pex, pexx;
			float qux, quxx;
	
	
			//runge kutta "k"
			float k1, kx1, l1, lx1, m1, mx1;
			float k2, kx2, l2, lx2, m2, mx2;
			
					
			

			k1 = dt *funcrot(rod[i],yu[i],yud[i],ro[i]);

			kx1 = dt * funcrotx(up(2,ro,rod,yu,i, 0.0f, 0.0f ,0.0f), yu[i], yud[i],rod[i], utp(2,yu,yud,i,0.0f,0.0f),ro[i]);
			
			
			pe = funcpe(ro[i],en[i]);
			pex = funcpex(rod[i],en[i],ro[i],end[i]);
			pexx = funcpexx(utp(2,ro,rod,i,0.0f,0.0f),en[i], rod[i], end[i], ro[i], utp(2,en,end,i,0.0f,0.0f));


			if ( yud[i]<0 )
			{


				cs = funccs(en[i]);
				
				qu = funcqu(ro[i],cs,yud[i]);
				qux = funcqux(cs, rod[i], yud[i], ro[i], utp(2,yu,yud,i,0.0f,0.0f));
				quxx = funcquxx(cs, utp(2,ro,rod,i,0.0f,0.0f), yud[i], rod[i], utp(2,yu,yud,i,0.0f,0.0f),ro[i], utp(3,yu,yud,i,0.0f,0.0f));
				

				l1 = dt * funcyut (yu[i], yud[i], pex, qux, ro[i]);
				
				lx1 = dt * funcyutx(yud[i], yu[i], up(2,yu,yud,yu,i,0.0f,0.0f,0.0f), pexx, quxx, ro[i], pex, qux, rod[i]);
								
				m1 = dt * funcent (yu[i], end[i], pe, qu, yud[i], ro[i]);
				
				mx1 = dt * funcentx (yud[i], end[i], yu[i], up(2,en,end,yu,i,0.0f,0.0f,0.0f), pex, qux, ro[i], pe, qu, utp(2,yu,yud,i,0.0f,0.0f), rod[i]);

				pe =  funcpe(ro[i] + k1, en[i]+m1);
				pex = funcpex(rod[i]+kx1, en[i]+m1, ro[i]+k1, end[i]+mx1);
				pexx = funcpexx(utp(2,ro,rod,i,k1,kx1),en[i]+m1, rod[i]+kx1, end[i]+mx1, ro[i]+k1, utp(2,en,end,i,m1,mx1));
				
				
				cs = funccs(en[i]+m1);
				qu = funcqu(ro[i]+k1,cs,yud[i]+lx1);
				qux = funcqux(cs, rod[i]+kx1, yud[i]+ lx1, ro[i] +k1, utp(2,yu,yud,i,l1,lx1));
				quxx = funcquxx(cs, utp(2,ro,rod,i,k1,kx1), yud[i]+lx1, rod[i]+kx1, utp(2,yu,yud,i,l1,lx1), ro[i]+k1, utp(3,yu,yud,i,l1,lx1));

				
				
				k2 = dt * funcrot( rod[i]+kx1 , yu[i]+l1 , yud[i]+lx1 , ro[i]+k1 );
				
				kx2 = dt* funcrotx( up(2,ro,rod,yu,i,k1,kx1,l1) , yu[i]+l1 , yud[i]+lx1 , rod[i]+kx1 , utp(2,yu,yud,i,l1,lx1) , ro[i]+k1);
				
				l2 = dt * funcyut ( yu[i]+l1 , yud[i]+lx1 , pex, qux, ro[i]);

				lx2 = dt * funcyutx(yud[i]+lx1, yu[i]+l1, up(2,yu,yud,yu,i,l1,lx1,l1),pexx,quxx,ro[i]+k1,pex,qux,rod[i]+kx1);
				
				m2 = dt *funcent(yu[i] +l1, end[i] + mx1, pe, qu, yud[i]+lx1, ro[i]+k1);

				mx2 = dt * funcentx(yud[i]+lx1, end[i]+mx1, yu[i]+l1, up(2,en,end,yu,i,m1,mx1,l1), pex, qux, ro[i]+k1, pe, qu,
					  utp(2,yu,yud,i,l1,lx1), rod[i]+kx1);

			} //end if "kapoia paragwgos taxythtas einai arnitikh (compression region)
			else {
				
				l1 = dt * funcyut (yu[i], yud[i], pex, 0.0f, ro[i]);
				
				lx1 = dt * funcyutx(yud[i], yu[i], up(2,yu,yud,yu,i,0.0f,0.0f,0.0f), pexx, 0.0f, ro[i], pex, 0.0f, rod[i]);

				m1 = dt * funcent (yu[i], end[i], pe, 0.0f, yud[i], ro[i]);
				
				mx1 = dt * funcentx (yud[i], end[i], yu[i], up(2,en,end,yu,i,0.0f,0.0f,0.0f), pex, 0.0f, ro[i], pe, 0.0f, utp(2,yu,yud,i,0.0f,0.0f), rod[i]);
				
				
				pe =  funcpe(ro[i] + k1, en[i]+m1);
				pex = funcpex(rod[i]+kx1, en[i]+m1, ro[i]+k1, end[i]+mx1);
				pexx = funcpexx(utp(2,ro,rod,i,k1,kx1),en[i]+m1, rod[i]+kx1, end[i]+mx1, ro[i]+k1, utp(2,en,end,i,m1,mx1));
				
				
				
				k2 = dt * funcrot( rod[i]+kx1 , yu[i]+l1 , yud[i]+lx1 , ro[i]+k1 );
				
				kx2 = dt* funcrotx( up(2,ro,rod,yu,i,k1,kx1,l1) , yu[i]+l1 , yud[i]+lx1 , rod[i]+kx1 , utp(2,yu,yud,i,l1,lx1) , ro[i]+k1);
				
				l2 = dt * funcyut ( yu[i]+l1 , yud[i]+lx1 , pex, 0.0f, ro[i]);
				
				lx2 = dt * funcyutx(yud[i]+lx1, yu[i]+l1, up(2,yu,yud,yu,i,l1,lx1,l1),pexx,0.0f,ro[i]+k1,pex,0.0f,rod[i]+kx1);
				
				m2 = dt *funcent(yu[i] +l1, end[i] + mx1, pe, 0.0f, yud[i]+lx1, ro[i]+k1);
				
				mx2 = dt * funcentx(yud[i]+lx1, end[i]+mx1, yu[i]+l1, up(2,en,end,yu,i,m1,mx1,l1), pex, 0.0f, ro[i]+k1, pe, 0.0f,
					  utp(2,yu,yud,i,l1,lx1), rod[i]+kx1);
				

			} //end else - mh compression region
			
			
			//e3eli3h ston xrono me Runge Kutta
						
			ronew[i] = ro[i] + 1.0f/2.0f*(k1 + k2);
			/*if(isnan(ronew[i])){
				cout << "abort : ronew[i] = NaN   x:" << i/100. << "\t t:" << t;
				return 0;
			}*/
			rodnew[i] = rod[i] + 1.0f/2.0f*(kx1 + kx2);
			
			yunew[i] = yu[i] + 1.0f/2.0f*(l1 + l2);
			yudnew[i] = yud[i] + 1.0f/2.0f*(lx1 + lx2);
			
			ennew[i] = en[i] + 1.0f/2.0f*(m1 + m2);
			endnew[i] = end[i] + 1.0f/2.0f*(mx1 + mx2);
			

	
			
	}	//end if oti eimaste entos plegmatos (afhnei ape3w ta dyo akriana shmeia)	
					
	
	
	
}









__device__ float utp(int par, float* val, float* der, int ind, float k, float l) {

	float fi = val[ind] + k;
	float fim1 = val[ind - 1] + k;
	float fip1 = val[ind + 1] + k;

	float fxi = der[ind] + l;
	float fxim1 = der[ind - 1] + l;
	float fxip1 = der[ind + 1] + l;
	
	
	switch (par) {
	case 2:
		float dc;
			
		dc = 1.0f/powf(dx,2.0f) *(fip1 - 2.0f*fi + fim1) - 1.0f/4.0f/dx *(fxip1 - fxim1);
		return 2.0f*dc;	
		break;
	case 3:
		float cc;
			
		cc = 5.0f/4.0f/powf(dx,3.0f) *(fip1 - fim1) - 1.0f/4.0f/powf(dx,2.0f) *(fxip1 + 8.0f*fxi + fxim1);
		return 6.0f*cc;
		break;
	case 4:
		float bc;
		
		bc = -1.0f/2.0f/powf(dx,4.0f) *(fip1 - 2.0f*fi + fim1) + 1.0f/4.0f/powf(dx,3.0f)*(fxip1 - fxim1);
		return 24.0f*bc;
		break;
	case 5:
		float ac;
		
		ac = - 3.0f/4.0f/powf(dx,5.0f) *(fip1 - fim1) + 1.0f/4.0f/powf(dx,4.0f) *(fxip1 + 4.0f*fxi + fxim1);
		return 120.0f*ac;
		break;
	default:
		return 0.0f;
	}
	
	return 0;
	
} //end function utp




__device__ float up (int par, float* val, float* der, float* vel, int ind, float k, float l, float m) {

//  oi sxoliasmenes synarthseis einai gia thn periptwsh pou u<0
	
	float fi = val[ind] + k;
	float fim1 = val[ind - 1] + k;
	float fip1 = val[ind + 1] + k;

	float fxi = der[ind] + l;
	float fxim1 = der[ind - 1] + l;
	float fxip1 = der[ind + 1] + l;
	
		
	switch (par) {
	case 2:
		float bu;
		
		if (vel[ind] + m < 0) 
			bu = - (2.0f*fxi + fxip1)/dx - 3.0f/powf(dx,2.0f)*(fi - fip1);
		else
			bu = (2.0f*fxi + fxim1)/dx - 3.0f/powf(dx,2.0f)*(fi - fim1);
				
		return 2.0f*bu;
		break;
	case 3:
		float au;
		
		if (vel[ind] + m <0)
			au = (fxi + fxip1)/powf(dx,2.0f) + 2.0f/powf(dx,3.0f)*(fi - fip1);
		else
			au = (fxi + fxim1)/powf(dx,2.0f) - 2.0f/powf(dx,3.0f)*(fi - fim1);
		
		return 6.0f*au;
		break;
	default:
		return 0.0f;
	}
	
		
	return 0;
} // end function up







//rot
__device__ float funcrot (float rod, float yu, float yud, float ro) {
	return -rod*yu - yud*ro;
}


//rotx
__device__ float funcrotx (float roxx, float yu, float yud, float rod, float yuxx, float ro) {
	return -roxx*yu - 2.0f*yud*rod - yuxx*ro;
}

//yut
__device__ float funcyut (float yu, float yud, float pex, float qux, float ro) {
	return -yu*yud - (pex+qux)/ro ;
}


//yutx
__device__ float funcyutx (float yud, float yu, float yuxx, float pexx, float quxx, float ro, float pex, float qux, float rod) {
	return - powf(yud,2.0f) - yu*yuxx - (pexx+quxx)/ro + (pex + qux)*rod/powf(ro,2.0f) ;
}

//ent
__device__ float funcent (float yu, float end, float pe, float qu, float yud, float ro) {
	return - yu* end - (pe + qu)*yud / ro;
}

//entx
__device__ float funcentx (float yud, float end, float yu, float enxx, float pex, float qux, float ro, float pe, float qu, float yuxx,
				float rod)  {
	return -yud*end - yu*enxx - (pex + qux)*yud/ro - (pe + qu)*yuxx/ro + (pe + qu)*yud*rod/powf(ro,2.0f) ;
}




//pe
__device__ float funcpe(float ro, float en) {
	return (g - 1.0f)*ro*en;
}

//pex
__device__ float funcpex(float rod, float en, float ro, float end) {
	return (g - 1.0f)*(rod*en + ro*end);
}

//pexx
__device__ float funcpexx(float roxx, float en, float rod, float end, float ro, float enxx) {
	return (g - 1.0f)*(roxx*en + 2.0f*rod*end + ro*enxx);
}

//cs
__device__ float funccs (float en) {
	return sqrtf(g*(g - 1.0f)*en);
}

//qu
__device__ float funcqu (float ro, float cs, float yud) {

	float qu1 = -a *dx* ro * cs * yud ;
	float qu2 = b * powf(dx,2.0f) * ro*powf(yud,2.0f);

	return qu1 + qu2 ;
}

//qux
__device__ float funcqux (float cs, float rod, float yud, float ro, float yuxx) {

	float qu1 = -a*dx*cs*(rod*yud + ro*yuxx) ;
	float qu2 = b * powf(dx,2.0f)*( rod*powf(yud,2.0f) + 2.0f* ro*yud*yuxx );

	return  qu1 + qu2;
}

//quxx
__device__ float funcquxx (float cs, float roxx, float yud, float rod, float yuxx, float ro, float yu3x) {

	float qu1 = -a*dx*cs* (roxx*yud + 2.0f*rod*yuxx + ro*yu3x) ;
	float qu2 = b * powf(dx,2.0f)*( roxx*powf(yud,2.0f) + 4.0f* rod * yud *yuxx
			+ 2.0f* ro *powf(yuxx,2.0f) + 2.0f*ro*yud*yu3x  );

	return qu1 + qu2;
}














